<?php
/**
 * Template class
 * @author TrackAsia Code<support@trackasia.com>
 * @version 1.0.0
 * @package Maps
 */

if ( ! class_exists( 'TRACKASIAP_Template' ) ) {

	/**
	 * Controller class to display views.
	 * @author: TrackAsia Code<support@trackasia.com>
	 * @version: 4.1.6
	 * @package: Maps
	 */

	class TRACKASIAP_Template extends FlipperCode_HTML_Markup{


		function __construct($options = array()) {
			
			$productOverview = array(
				'subscribe_mailing_list' => esc_html__( 'Subscribe to our mailing list', 'wp-trackasia-maps' ),
				'product_info_heading' => esc_html__( 'Product Information', 'wp-trackasia-maps' ),
				'product_info_desc' => esc_html__( 'For each of our plugins, we have created step by step detailed tutorials that helps you to get started quickly.', 'wp-trackasia-maps' ),
				'start_now' => esc_html__( 'START NOW', 'wp-trackasia-maps' ),
				'installed_version' => esc_html__( 'Installed version :', 'wp-trackasia-maps' ),
				'latest_version_available' => esc_html__( 'Latest Version Available : ', 'wp-trackasia-maps' ),
				'updates_available' => esc_html__( 'Update Available', 'wp-trackasia-maps' ),

				'subscribe_now' => array(
					'heading' => esc_html__( 'Subscribe Now', 'wp-trackasia-maps' ),
					'desc1' => esc_html__( 'Receive updates on our new product features and new products effortlessly.', 'wp-trackasia-maps' ),
					'desc2' => esc_html__( 'We will not share your email addresses in any case.', 'wp-trackasia-maps' ),
				),

				'product_support' => array(
					'heading' => esc_html__( 'Product Support', 'wp-trackasia-maps' ),
					'desc' => esc_html__( 'For our each product we have very well explained starting guide to get you started in matter of minutes.', 'wp-trackasia-maps' ),
					'click_here' => esc_html__( ' Click Here', 'wp-trackasia-maps' ),
					'desc2' => esc_html__( 'For our each product we have set up demo pages where you can see the plugin in working mode. You can see a working demo before making a purchase.', 'wp-trackasia-maps' ),
				),
				'create_support_ticket' => array(
                    'heading' => esc_html__( 'Create Support Ticket', 'wp-trackasia-maps' ),
                    'desc1' => esc_html__( 'If you have any question and need our help, click below button to create a support ticket and our support team will assist you asap.', 'wp-trackasia-maps' ),
                    'link' => array( 
						'label' => esc_html__( 'Create Ticket', 'wp-trackasia-maps' ),
						'url' => 'https://weplugins.com/support/'
					)
                ),

                'hire_wp_expert' => array(
                    'heading' => esc_html__( 'Hire Wordpress Expert', 'wp-trackasia-maps' ),
                    'desc' => esc_html__( 'Do you have a custom requirement which is missing in this plugin?', 'wp-trackasia-maps' ),
                    'desc1' => esc_html__( 'We can customize this plugin according to your needs. Click below button to send an quotation request.', 'wp-trackasia-maps' ),
                    'link' => array(
                                    
                        'label' => esc_html__( 'Request a quotation', 'wp-trackasia-maps' ),
                        'url' => 'https://weplugins.com/contact/'
					)
                ),
			);  
						
			$productInfo = array('productName' => esc_html__('TRACK ASIA MAPS','wp-trackasia-maps'), 
                        'productSlug' => 'wp-trackasia-maps',
                        'product_tag_line' => esc_html__('World\'s most advanced google map plugin','wp-trackasia-maps'),
                        'productTextDomain' => 'wp-trackasia-maps',
                        'productVersion' => TRACKASIAP_VERSION,
                        'videoURL' => 'https://www.youtube.com/playlist?list=PLlCp-8jiD3p2PYJI1QCIvjhYALuRGBJ2A',
                        'docURL' => 'https://www.wpmapspro.com/tutorials/',
                        'demoURL' => 'https://www.wpmapspro.com/?utm_source=wordpress&utm_medium=liteversion&utm_campaign=freemium&utm_id=freemium',
                        'start_now_url' => admin_url('admin.php?page=trackasia_how_overview'),
                        'productSaleURL' => 'https://www.wpmapspro.com/?utm_source=wordpress&utm_medium=liteversion&utm_campaign=freemium&utm_id=freemium',
                        'multisiteLicence' => 'https://www.wpmapspro.com/?utm_source=wordpress&utm_medium=liteversion&utm_campaign=freemium&utm_id=freemium',
                        'productOverview' => $productOverview,
   			 );
			$productInfo = array_merge($productInfo, $options);
			parent::__construct($productInfo);

		}

	}
	
}
