<?php
/**
 * Manage Maps
 * @package Maps
 */
  $form  = new TRACKASIAP_Template();
  // echo wp_kses_post( $form->show_header() );
  
  if(!class_exists('WP_List_Table_Helper')){
	
	$tabular_file = TRACKASIAP_CORE_CLASSES.'class.tabular.php';
	if ( file_exists( $tabular_file ) ) {
	   require_once( $tabular_file );
	}
	
  }

if ( class_exists( 'WP_List_Table_Helper' ) and ! class_exists( 'TRACKASIAP_Maps_Table' ) ) {

	/**
	 * Display maps manager.
	 */
	class TRACKASIAP_Maps_Table extends WP_List_Table_Helper {
		/**
	  	 * Intialize manage category table.
	  	 * @param array $tableinfo Table's properties.
	  	 */
		public function __construct($tableinfo) {
			parent::__construct( $tableinfo ); }
		/**
	  	 * Output for Shortcode column.
	  	 * @param array $item Map Row.
	  	 */
		public function column_shortcodes($item) {
			echo esc_html('[put_trackasia id='.$item->map_id.']');	}
		/**
		 * Clone of the map.
		 * @param  integer $item Map ID.
		 */
		public function copy() {
			
			$this->authenticate_action_requests();
			$map_id = intval( $_GET['map_id'] );
			$modelFactory = new TRACKASIAP_Model();
			$map_obj = $modelFactory->create_object( 'map' );
			$map = $map_obj->copy( $map_id );
			$this->prepare_items();
			$this->listing();
		}

	}

	global $wpdb;
	$columns = array(
	'map_title'  => esc_html__('Map Title','wp-trackasia-maps'),
	'map_width' => esc_html__('Map Width','wp-trackasia-maps'),
	'map_height' => esc_html__('Map Height','wp-trackasia-maps'),
	'map_zoom_level' => esc_html__('Map Zoom Level','wp-trackasia-maps'),
	'map_type' => esc_html__('Map Type','wp-trackasia-maps'),
	'shortcodes' => esc_html__('Map Shortcode','wp-trackasia-maps')
	);
	$sortable  = array( 'map_title','map_width','map_height','map_zoom_level','map_type' );
	$tableinfo = array(
	'table' => $wpdb->prefix.'create_map',
	'plugin' => 'wp-trackasia-maps',
	'textdomain' => 'wp-trackasia-maps',
	'singular_label' => 'map',
	'plural_label' => 'maps',
	'admin_listing_page_name' => 'trackasia_manage_map',
	'admin_add_page_name' => 'trackasia_form_map',
	'primary_col' => 'map_id',
	'columns' => $columns,
	'sortable' => $sortable,
	'per_page' => 20,
	'form_id' => 'trackasia_manage_maps',
	'form_class' => 'trackasia_listing_form trackasia_manage_maps',
	'actions' => array( 'edit','delete','copy' ),
	'bulk_actions' => array( 'delete' => esc_html__( 'Delete', 'wp-trackasia-maps' ) ),
	'col_showing_links' => 'map_title',
	'searchExclude' => array( 'shortcodes' ),
	'translation' => array(
			'manage_heading'      => esc_html__( 'Manage Maps', 'wp-trackasia-maps' ),
			'add_button'          => esc_html__( 'Add Map', 'wp-trackasia-maps' ),
			'delete_msg'          => esc_html__( 'Maps was deleted successfully.', 'wp-trackasia-maps' ),
			'bulk_delete_msg'     => esc_html__( 'Maps were deleted successfully.', 'wp-trackasia-maps' ),
			'insert_msg'          => esc_html__( 'Map was created successfully.', 'wp-trackasia-maps' ),
			'update_msg'          => esc_html__( 'Map was updated successfully.', 'wp-trackasia-maps' ),
			'no_records_found'    => esc_html__( 'No maps were found.', 'wp-trackasia-maps' ),
	)
	);
	$obj = new TRACKASIAP_Maps_Table( $tableinfo );
}
