<?php
/**
 * Contro Positioning over google maps.
 * @package Maps
 * @author TrackAsia Code <support@trackasia.com>
 */

$positions = array(
'TOP_LEFT' => esc_html__( 'Top Left', 'wp-trackasia-maps' ),
'TOP_RIGHT' => esc_html__( 'Top Right', 'wp-trackasia-maps' ),
'LEFT_TOP' => esc_html__( 'Left Top','wp-trackasia-maps' ),
'RIGHT_TOP' => esc_html__( 'Right Top', 'wp-trackasia-maps' ),
'TOP_CENTER' => esc_html__( 'Top Center', 'wp-trackasia-maps' ),
'LEFT_CENTER' => esc_html__( 'Left Center', 'wp-trackasia-maps' ),
'RIGHT_CENTER' => esc_html__( 'Right Center', 'wp-trackasia-maps' ),
'BOTTOM_RIGHT' => esc_html__( 'Bottom Right', 'wp-trackasia-maps' ),
'LEFT_BOTTOM' => esc_html__( 'Left Bottom', 'wp-trackasia-maps' ),
'RIGHT_BOTTOM' => esc_html__( 'Right Bottom', 'wp-trackasia-maps' ),
'BOTTOM_CENTER' => esc_html__( 'Bottom Center', 'wp-trackasia-maps' ),
'BOTTOM_LEFT' => esc_html__( 'Bottom Left', 'wp-trackasia-maps' ),
'BOTTOM_RIGHT' => esc_html__( 'Bottom Right', 'wp-trackasia-maps' )
);

$form->add_element( 'group', 'map_control_position_setting', array(
	'value' => esc_html__( 'Control Position(s) Settings', 'wp-trackasia-maps' ),
	'before' => '<div class="fc-12">',
	'after' => '</div>',
	// 'tutorial_link'=>'https://www.wpmapspro.com/docs/different-type-of-control-position-settings-in-map/'
));

$form->add_element( 'select', 'map_all_control[zoom_control_position]', array(
	'lable' => esc_html__( 'Zoom Control', 'wp-trackasia-maps' ),
	'current' => (isset($_POST['map_all_control']['zoom_control_position'])) ? sanitize_text_field($_POST['map_all_control']['zoom_control_position']) : '',
	'desc' => esc_html__( 'Please select position of zoom control.', 'wp-trackasia-maps' ),
	'options' => $positions,
));
$zoom_control_style = array( 'LARGE' => 'Large','SMALL' => 'Small' );
$form->add_element( 'select', 'map_all_control[zoom_control_style]', array(
	'lable' => esc_html__( 'Zoom Control Style', 'wp-trackasia-maps' ),
	'current' => (isset($_POST['map_all_control']['zoom_control_style']))? sanitize_text_field($_POST['map_all_control']['zoom_control_style']) : '',
	'desc' => esc_html__( 'Please select style of zoom control.', 'wp-trackasia-maps' ),
	'options' => $zoom_control_style,
));


$map_type_control_style = array( 'HORIZONTAL_BAR' => 'Horizontal Bar', 'DROPDOWN_MENU' => 'Dropdown Menu' );
$form->add_element( 'select', 'map_all_control[map_type_control_style]', array(
	'lable' => esc_html__( 'Map Type Control Style', 'wp-trackasia-maps' ),
	'current' => (isset($_POST['map_all_control']['map_type_control_style'])) ? sanitize_text_field($_POST['map_all_control']['map_type_control_style']) : '',
	'desc' => esc_html__( 'Please select style of map type control.', 'wp-trackasia-maps' ),
	'options' => $map_type_control_style,
));


$form->add_element( 'select', 'map_all_control[full_screen_control_position]', array(
	'lable' => esc_html__( 'Full Screen Control', 'wp-trackasia-maps' ),
	'default_value' => 'TOP_RIGHT',
	'current' => (isset($_POST['map_all_control']['full_screen_control_position'])) ? sanitize_text_field($_POST['map_all_control']['full_screen_control_position']) : '',
	'desc' => esc_html__( 'Please select position of full screen control.', 'wp-trackasia-maps' ),
	'options' => $positions,
));


// Search Control Position
$form->add_element( 'select', 'map_all_control[search_control_position]', array(
	'lable' => esc_html__( 'Search Control', 'wp-trackasia-maps' ),
	
	'current' => ( isset($_POST['map_all_control']['search_control_position']) ) ? sanitize_text_field($_POST['map_all_control']['search_control_position']) : '',
	'desc' => esc_html__( 'Please select position of search box control.', 'wp-trackasia-maps' ),
	'options' => $positions,
));
