<?php

/**
 * Contro Positioning over google maps.
 * @package Maps
 * @author TrackAsia Code <support@trackasia.com>
 */

$form->add_element('group', 'map_control_settings', array(
	'value' => esc_html__('Infowindow Settings', 'wp-trackasia-maps'),
	'before' => '<div class="fc-12">',
	'after' => '</div>',
));
$url = admin_url('admin.php?page=trackasia_how_overview');
$link =  esc_html__('Enter placeholders {marker_title},{marker_address},{marker_message},{marker_latitude},{marker_longitude}.', 'wp-trackasia-maps');


if (isset($_POST) && isset($_POST['map_all_control']) && isset($_POST['map_all_control']['infowindow_openoption']) && 'mouseclick' == $_POST['map_all_control']['infowindow_openoption']) {
	$_POST['map_all_control']['infowindow_openoption'] = 'click';
} else if (isset($_POST) && isset($_POST['map_all_control']) && isset($_POST['map_all_control']['infowindow_openoption']) && 'mousehover' == $_POST['map_all_control']['infowindow_openoption']) {
	$_POST['map_all_control']['infowindow_openoption'] = 'mouseover';
}

$event = array('click' => esc_html__('Mouse Click', 'wp-trackasia-maps'), 'mouseover' => esc_html__('Mouse Hover', 'wp-trackasia-maps'));
$form->add_element('select', 'map_all_control[infowindow_openoption]', array(
	'lable' => esc_html__('Show Infowindow on', 'wp-trackasia-maps'),
	'current' => (isset($_POST['map_all_control']['infowindow_openoption'])) ? sanitize_text_field($_POST['map_all_control']['infowindow_openoption']) : '',
	'desc' => esc_html__('Open infowindow on Mouse Click or Mouse Hover.', 'wp-trackasia-maps'),
	'options' => $event,
));

$form->add_element('image_picker', 'map_all_control[marker_default_icon]', array(
	'lable' => esc_html__('Choose Marker Image', 'wp-trackasia-maps'),
	'src' => (isset($_POST['map_all_control']['marker_default_icon'])  ? wp_unslash($_POST['map_all_control']['marker_default_icon']) : TRACKASIAP_IMAGES . '/default_marker.png'),
	'required' => false,
	'choose_button' => esc_html__('Choose', 'wp-trackasia-maps'),
	'remove_button' => esc_html__('Remove', 'wp-trackasia-maps'),
	'id' => 'marker_category_icon',
));

$form->add_element('checkbox', 'map_all_control[infowindow_open]', array(
	'lable' => esc_html__('InfoWindow Open', 'wp-trackasia-maps'),
	'value' => 'true',
	'id' => 'trackasia_infowindow_open',
	'current' => (isset($_POST['map_all_control']['infowindow_open'])) ? sanitize_text_field($_POST['map_all_control']['infowindow_open']) : '',
	'desc' => esc_html__('Please check to enable infowindow default open.', 'wp-trackasia-maps'),
	'class' => 'chkbox_class',
));

$form->add_element('checkbox', 'map_all_control[infowindow_close]', array(
	'lable' => esc_html__('Close InfoWindow', 'wp-trackasia-maps'),
	'value' => 'true',
	'id' => 'trackasia_infowindow_close',
	'current' => (isset($_POST['map_all_control']['infowindow_close'])) ? sanitize_text_field($_POST['map_all_control']['infowindow_close']) : '',
	'desc' => esc_html__('Please check to close infowindow on map click.', 'wp-trackasia-maps'),
	'class' => 'chkbox_class',
));

// $event = array('' => esc_html__('Select Animation', 'wp-trackasia-maps'), 'click' => esc_html__('Mouse Click', 'wp-trackasia-maps'), 'mouseover' => esc_html__('Mouse Hover', 'wp-trackasia-maps'));
// $form->add_element('select', 'map_all_control[infowindow_bounce_animation]', array(
// 	'lable' => esc_html__('Bounce Animation', 'wp-trackasia-maps'),
// 	'current' => (isset($_POST['map_all_control']['infowindow_bounce_animation'])) ? sanitize_text_field($_POST['map_all_control']['infowindow_bounce_animation']) : '',
// 	'desc' => esc_html__('Apply bounce animation on mousehover or mouse click. BOUNCE indicates that the marker should bounce in place.', 'wp-trackasia-maps'),
// 	'options' => $event,
// ));

// $form->add_element('checkbox', 'map_all_control[infowindow_drop_animation]', array(
// 	'lable' => esc_html__('Apply Drop Animation', 'wp-trackasia-maps'),
// 	'value' => 'true',
// 	'id' => 'infowindow_drop_animation',
// 	'current' => (isset($_POST['map_all_control']['infowindow_drop_animation'])) ? sanitize_text_field($_POST['map_all_control']['infowindow_drop_animation']) : '',
// 	'desc' => esc_html__('DROP indicates that the marker should drop from the top of the map. ', 'wp-trackasia-maps'),
// 	'class' => 'chkbox_class',
// ));


$info_default_value = <<<EOD
<div class="fc-item-box fc-itemcontent-padding ">
    <div class="fc-item-title">{marker_title} <span class="fc-badge info">{marker_category}</span></div>
    <div class="fc-item-content fc-item-body-text-color">
        <div class="fc-item-featured fc-left fc-item-top_space">
            {marker_image}
        </div>
        {marker_message}
    </div>
    <address class="fc-text">{marker_address}</address>
</div>';
EOD;

$location_placeholders = array(
		'{marker_id}',
		'{marker_title}',
		'{marker_image}',
		'{marker_address}',
		'{marker_message}',
		'{marker_category}',
		'{marker_icon}',
		'{marker_latitude}',
		'{marker_longitude}',
		'{marker_city}',
		'{marker_state}',
		'{marker_country}',
		'{marker_zoom}',
		'{marker_postal_code}',
		'{get_directions_link}',
	);

if( isset( $data['map_all_control']['infowindow_setting'] ) && !empty( $data['map_all_control']['infowindow_setting'] ) && !isset($data['map_all_control']['location_infowindow_skin']) ){
	$info_default_value = $data['map_all_control']['infowindow_setting'];
}

$form->add_element(
	'templates', 'map_all_control[location_infowindow_skin]', array(
		'parent_class'	=> 'fc-type-infowindow',
		'lable'	=> esc_html__( 'Infowindow Message for Locations', 'wp-trackasia-maps' ),
		'template_types'      => 'infowindow',
		'templatePath'        => TRACKASIAP_TEMPLATES,
		'templateURL'         => TRACKASIAP_TEMPLATES_URL,
		'data_placeholders'   => $location_placeholders,
		'customiser'          => 'true',
		'current'             => ( isset( $data['map_all_control']['location_infowindow_skin'] ) ) ? $data['map_all_control']['location_infowindow_skin'] : array(
			'name'       => 'default',
			'type'       => 'infowindow',
			'sourcecode' => $info_default_value,
		),
		'customiser_controls' => array( 'edit_mode', 'placeholder', 'sourcecode' ),
		// 'tutorial_link' => 'https://www.wpmapspro.com/docs/how-to-create-extra-fields-for-location-infowindow-2/'
	)
);

// $form->add_element(
// 	'group',
// 	'map_infowindow_post_message_settings',
// 	array(
// 		'value'  => esc_html__('Infowindow Message for Posts', 'wp-trackasia-maps').TRACKASIAP_PREMIUM_LINK,
// 		'before' => '<div class="fc-12">',
// 		'after'  => '</div>',
// 		'parent_class'		=> 'fc-locked',
// 	)
// );

// $form->add_element(
// 	'group',
// 	'map_infowindow_settings',
// 	array(
// 		'value'  => esc_html__('Infowindow Customization Settings', 'wp-trackasia-maps').TRACKASIAP_PREMIUM_LINK,
// 		'before' => '<div class="fc-12">',
// 		'after'  => '</div>',
// 		'parent_class'		=> 'fc-locked',
// 	)
// );


// $form->add_element('group', 'map_control_layers', array(
// 	'value' => esc_html__('Map Layers Settings', 'wp-trackasia-maps'),
// 	'before' => '<div class="fc-12">',
// 	'after' => '</div>',
// 	// 'tutorial_link' => 'https://www.wpmapspro.com/topic/layers/'
// ));

// $form->add_element('checkbox', 'map_layer_setting[choose_layer][traffic_layer]', array(
// 	'lable' => esc_html__('Traffic Layer', 'wp-trackasia-maps'),
// 	'value' => 'TrafficLayer',
// 	'id' => 'trackasia_traffic_layer',
// 	'current' => (isset($_POST['map_layer_setting']['choose_layer']['traffic_layer'])) ? sanitize_text_field($_POST['map_layer_setting']['choose_layer']['traffic_layer']) : '',
// 	'desc' => esc_html__('Please check to enable the traffic layer on map.', 'wp-trackasia-maps'),
// 	'class' => 'chkbox_class',
// ));

// $form->add_element('checkbox', 'map_layer_setting[choose_layer][transit_layer]', array(
// 	'lable' => esc_html__('Transit Layer', 'wp-trackasia-maps'),
// 	'value' => 'TransitLayer',
// 	'id' => 'trackasia_transit_layer',
// 	'current' => (isset($_POST['map_layer_setting']['choose_layer']['transit_layer'])) ? sanitize_text_field($_POST['map_layer_setting']['choose_layer']['transit_layer']) : '',
// 	'desc' => esc_html__('Please check to enable the transit layer on map.', 'wp-trackasia-maps'),
// 	'class' => 'chkbox_class',
// ));


// $form->add_element('checkbox', 'map_layer_setting[choose_layer][bicycling_layer]', array(
// 	'lable' => esc_html__('Bicycling Layer', 'wp-trackasia-maps'),
// 	'value' => 'BicyclingLayer',
// 	'id' => 'trackasia_bicycling_layer',
// 	'current' => (isset($_POST['map_layer_setting']['choose_layer']['bicycling_layer'])) ? sanitize_text_field($_POST['map_layer_setting']['choose_layer']['bicycling_layer']) : '',
// 	'desc' => esc_html__('Please check to enable the bicycling layer on map.', 'wp-trackasia-maps'),
// 	'class' => 'chkbox_class',
// ));
