<?php
/**
 * This class used to backup all tables for this plugins.
 *
 * @author TrackAsia Code <support@trackasia.com>
 * @version 3.0.0
 * @package Maps
 */


if ( isset( $_POST['operation'] ) and 'clean_database' == $_POST['operation'] ) {
	$clean_database = $response;
} else {
	$clean_database = array();
}

if ( isset( $_POST['operation'] ) and 'upload_sampledata' == $_POST['operation'] ) {
	$upload_sampledata = $response;
} else {
	$upload_sampledata = array();
}

	$import_form = new TRACKASIAP_Template();
	$import_form->form_id = 'install_sample_data_form';

	$import_form->set_header( esc_html__( 'Install Sample Data', 'wp-trackasia-maps' ), $upload_sampledata );

	$import_form->add_element(
		'group', 'install_database', array(
			'value'  => esc_html__( 'Install Sample Data', 'wp-trackasia-maps' ),
			'before' => '<div class="fc-12">',
			'after'  => '</div>',
		)
	);

	$import_form->add_element(
		'hidden', 'operation', array(
			'value' => 'upload_sampledata',
		)
	);

	$import_form->add_element(
		'message', 'sampledata_message', array(
			'value' => esc_html__( 'Click below to install sample data. This is very useful to get started. 2 categories, 5 locations and 1 map will be created for demonstration purpose.', 'wp-trackasia-maps' ),
			'class' => 'fc-msg fc-msg-info',
			'before' => '<div class="fc-12">',
			'after'  => '</div>',
		)
	);

	$import_form->add_element(
		'text', 'trackasia_sampledata_consent', array(
			'lable'  => esc_html__( 'Verify Action', 'wp-trackasia-maps' ),
			'class'  => 'form-control',
			'desc'   => esc_html__( 'Enter', 'wp-trackasia-maps' ).' "YES" '.esc_html__( '& submit the button below to install sample map data.', 'wp-trackasia-maps' ),
			'before' => '<div class="fc-6">',
			'after'  => '</div>',
		)
	);


	$import_form->add_element(
		'submit', 'trackasia_sampledata_submit', array(
			'value' => esc_html__( 'Create Sample Data', 'wp-trackasia-maps' ),
		)
	);

	$import_form->render();

	$form = new TRACKASIAP_Template(array( 'no_header' => true ));
	$form->form_id = 'clean_trackasia_database';
	$form->set_header( esc_html__( 'Clean Plugin Database', 'wp-trackasia-maps' ), $clean_database );

	$form->add_element(
		'group', 'clean_database', array(
			'value'  => esc_html__( 'Clean Plugin Database', 'wp-trackasia-maps' ),
			'before' => '<div class="fc-12">',
			'after'  => '</div>',
		)
	);

	$form->add_element(
		'hidden', 'operation', array(
			'value' => 'clean_database',
		)
	);

	$form->add_element(
		'message', 'backup_message', array(
			'value' => esc_html__( 'Enter "DELETE" in the below textbox and submit the form to remove all locations, maps, and categories i.e compelete database generated by our plugin. This method is not recommended on a live site as everything related to our plugin will be removed except plugin settings.', 'wp-trackasia-maps' ),
			'class' => 'fc-msg fc-msg-info',
			'before' => '<div class="fc-12">',
			'after'  => '</div>',
		)
	);

	$form->add_element(
		'text', 'trackasia_clean_consent', array(
			'lable'  => esc_html__( 'Verify Action', 'wp-trackasia-maps' ),
			'id'     => 'trackasia_consent',
			'class'  => 'form-control',
			'desc'   => esc_html__( 'Enter ', 'wp-trackasia-maps' ).' "DELETE" '.esc_html__( ' to give consent that you actually want to remove all maps data generated by our plugin.', 'wp-trackasia-maps' ),
			'before' => '<div class="fc-6">',
			'after'  => '</div>',
		)
	);

	$form->add_element(
		'submit', 'trackasia_cleandatabase_tools', array(
			'value' => esc_html__( 'Submit', 'wp-trackasia-maps' ),
		)
	);

	$form->render();

	
